[systemd-devel] [PATCH] src/systemd-bash-completion.sh: get rid of awk and grep
harald at redhat.com
harald at redhat.com
Tue Feb 21 05:49:05 PST 2012
From: Harald Hoyer <harald at redhat.com>
get rid of "awk" and "grep" calls. This can be done entirely in bash!
Signed-off-by: Harald Hoyer <harald at redhat.com>
---
src/systemd-bash-completion.sh | 45 ++++++++++++++++++++++++++-------------
1 files changed, 30 insertions(+), 15 deletions(-)
diff --git a/src/systemd-bash-completion.sh b/src/systemd-bash-completion.sh
index 176591f..7462b18 100644
--- a/src/systemd-bash-completion.sh
+++ b/src/systemd-bash-completion.sh
@@ -28,7 +28,8 @@ __contains_word () {
__filter_units_by_property () {
local property=$1 value=$2 ; shift ; shift
local -a units=( $* )
- local -a props=( $(__systemctl show --property "$property" -- ${units[*]} | grep -v ^$) )
+ local -a props=( $(__systemctl show --property "$property" -- ${units[*]} \
+ | while read line; do [[ $line ]] && echo $line; done) )
for ((i=0; $i < ${#units[*]}; i++)); do
if [[ "${props[i]}" = "$property=$value" ]]; then
echo "${units[i]}"
@@ -36,13 +37,20 @@ __filter_units_by_property () {
done
}
-__get_all_units () { __systemctl list-units --all | awk ' {print $1}' ; }
-__get_active_units () { __systemctl list-units | awk ' {print $1}' ; }
-__get_inactive_units () { __systemctl list-units --all | awk '$3 == "inactive" {print $1}' ; }
-__get_failed_units () { __systemctl list-units | awk '$3 == "failed" {print $1}' ; }
-__get_enabled_units () { __systemctl list-unit-files | awk '$2 == "enabled" {print $1}' ; }
-__get_disabled_units () { __systemctl list-unit-files | awk '$2 == "disabled" {print $1}' ; }
-__get_masked_units () { __systemctl list-unit-files | awk '$2 == "masked" {print $1}' ; }
+__get_all_units () { __systemctl list-units --all \
+ | { while read a b; do echo $a; done; }; }
+__get_active_units () { __systemctl list-units \
+ | { while read a b; do echo $a; done; }; }
+__get_inactive_units () { __systemctl list-units --all \
+ | { while read a b c d; do [[ $c == "inactive" ]] && echo $a; done; }; }
+__get_failed_units () { __systemctl list-units \
+ | { while read a b c d; do [[ $c == "failed" ]] && echo $a; done; }; }
+__get_enabled_units () { __systemctl list-unit-files \
+ | { while read a b c ; do [[ $b == "enabled" ]] && echo $a; done; }; }
+__get_disabled_units () { __systemctl list-unit-files \
+ | { while read a b c ; do [[ $b == "disabled" ]] && echo $a; done; }; }
+__get_masked_units () { __systemctl list-unit-files \
+ | { while read a b c ; do [[ $b == "masked" ]] && echo $a; done; }; }
_systemctl () {
local cur=${COMP_WORDS[COMP_CWORD]} prev=${COMP_WORDS[COMP_CWORD-1]}
@@ -133,11 +141,17 @@ _systemctl () {
elif __contains_word "$verb" ${VERBS[STARTABLE_UNITS]}; then
comps=$( __filter_units_by_property CanStart yes \
- $( __get_inactive_units | grep -Ev '\.(device|snapshot)$' ))
+ $( __get_inactive_units \
+ | while read line; do \
+ [[ "$line" =~ .(device|snapshot)$ ]] || echo $line; \
+ done ))
elif __contains_word "$verb" ${VERBS[RESTARTABLE_UNITS]}; then
comps=$( __filter_units_by_property CanStart yes \
- $( __get_all_units | grep -Ev '\.(device|snapshot|socket|timer)$' ))
+ $( __get_all_units | \
+ | while read line; do \
+ [[ "$line" =~ .(device|snapshot|socket|timer)$ ]] || echo $line; \
+ done ))
elif __contains_word "$verb" ${VERBS[STOPPABLE_UNITS]}; then
comps=$( __filter_units_by_property CanStop yes \
@@ -161,10 +175,11 @@ _systemctl () {
comps=''
elif __contains_word "$verb" ${VERBS[JOBS]}; then
- comps=$( __systemctl list-jobs | awk '{print $1}' )
+ comps=$( __systemctl list-jobs | { while read a b; do echo $a; done; } )
elif __contains_word "$verb" ${VERBS[SNAPSHOTS]}; then
- comps=$( __systemctl list-units --type snapshot --full --all | awk '{print $1}' )
+ comps=$( __systemctl list-units --type snapshot --full --all \
+ | { while read a b; do echo $a; done; } )
elif __contains_word "$verb" ${VERBS[ENVS]}; then
comps=$( __systemctl show-environment | sed 's_\([^=]\+=\).*_\1_' )
@@ -180,9 +195,9 @@ _systemctl () {
}
complete -F _systemctl systemctl
-__get_all_sessions () { systemd-loginctl list-sessions | awk '{print $1}' ; }
-__get_all_users () { systemd-loginctl list-users | awk '{print $2}' ; }
-__get_all_seats () { systemd-loginctl list-seats | awk '{print $1}' ; }
+__get_all_sessions () { systemd-loginctl list-sessions | { while read a b; do echo $a; done; } ; }
+__get_all_users () { systemd-loginctl list-users | { while read a b; do echo $b; done; } ; }
+__get_all_seats () { systemd-loginctl list-seats | { while read a b; do echo $a; done; } ; }
_systemd_loginctl () {
local cur=${COMP_WORDS[COMP_CWORD]} prev=${COMP_WORDS[COMP_CWORD-1]}
--
1.7.9.1
More information about the systemd-devel
mailing list